<template>
  <div class="post_detail_container">
    <a-page-header title="返回" :sub-title="tabLabel" @back="handleBack"/>
    <a-card hoverable>
      <div class="post_title">{{ post.headline }}</div>
      <div class="post_user_time">
        <span>作者：{{ post.user_name }}</span>
        <span>{{ timeDate }}</span>
      </div>
      <div class="post_content">{{ post.content }}</div>
      <div class="agree-oppo">
        <span key="comment-basic-like">
          <a-icon type="like" style="font-size: 18px" @click="like"/>
          <span style="'padding-left': '8px';cursor: auto"> {{post.agree_count}}</span>
        </span>
        <span key="comment-basic-dislike">
          <a-icon type="dislike" style="font-size: 18px" @click="dislike"/>
          <span style="'padding-left': '8px';cursor: auto"> {{post.oppo_count}}</span>
        </span>
      </div>
    </a-card>
    <comment-area ></comment-area>
    <comment-message></comment-message>
  </div>
</template>

<script>
import CommentMessage from "../../components/CommentMessage";
import CommentArea from "../../components/CommentArea";
import {mapActions, mapState} from "vuex";

export default {
  name: "PostDetail",
  components: { CommentMessage, CommentArea},
  data() {
    return {
      //当前tab页
      tabLabel: "",
      //帖子详情
      post: {},
    }
  },

  computed: {
    ...mapState('discuss', ['post_id']),
    timeDate() {
      let time = new Date(this.post.create_time)
      return this.$moment(time).format('yyyy/MM/DD HH:mm:ss')
    }
  },
  created() {
    this.tabLabel = this.$route.query.tabLabel;
    this.$store.state.discuss.post_id = this.$route.query.id
    this.$store.state.discuss.discussTab = this.$route.query.currTab
    this.getPostDetail()
    this.getCommentList();
  },

  beforeRouteLeave(to, from, next) {
    next(() => {
      this.post = {}
    })
  },

  methods: {
    ...mapActions('discuss', ['getCommentList']),
    /*返回上一页*/
    handleBack() {
      this.$router.back();
    },

    getPostDetail() {
      this.$axios.get(`post/${this.post_id}`).then(res => {
        if (res.code === undefined) {
          this.post = res
        }
      })
    },

    like() {
      this.$axios.post('post/agree', {
        post_id: this.post.post_id
      }).then(res => {
        if (res.code == 0) {
          this.post.agree_count = this.post.agree_count + 1
        } else if (res.code == 501) {
          this.$notification.warn({message: res.info})
        } else {
          this.$notification.error({message:'操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message:'操作失败'})
      })
    },
    dislike() {
      this.$axios.post('post/oppo', {
        post_id: this.post.post_id
      }).then(res => {
        if (res.code == 0) {
          this.post.oppo_count = this.post.oppo_count + 1
        } else if (res.code == 501) {
          this.$notification.warn({message: res.info})
        } else {
          this.$notification.error({message:'操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message:'操作失败'})
      })
    },
  }
}
</script>

<style lang="less" scoped>
.post_detail_container {
  width: 800px;
  margin: 0 auto;
  text-align: left !important;
}

.post_detail_container > .ant-card {
  border-radius: 5px;
  margin-bottom: 10px;
}

.post_title {
  font-size: 16px;
  font-weight: bold;
}

.post_user_time {
  span:last-child {
    margin-left: 10px;
  }
}

.post_content {
  color: #888;
  margin-top: 20px;
}

.agree-oppo {
  margin-top: 20px;
  span {
    margin-right: 10px;
    font-size: 18px;
  }
}

/deep/ .ant-page-header {
  padding: 16px 0;
}
</style>